<?php
/**
 * Created by JetBrains PhpStorm.
 * User: geovanesantos
 * Date: 26/05/14
 * Time: 14:06
 * To change this template use File | Settings | File Templates.
 */

namespace Scheduler\Facade;


class ParameterFieldManager {
    // carrega os parâmetros da procedure no campo PARAMETERS, roda no onChange de PROCEDURE_NAME
    public static function loadParameters(){

        $procedure=tk_get_field_value("PROCEDURE_NAME");

        //ver se o popup recarregou dados(abrindo o popup de novo após ter editado dados).
        //se sim, não deve rodar uma vez, pois carregar dados dispara essa função
        //o que sobrescreveria os dados editados anteriormente

        try{ // testa para ver se já rodou, mas a variável pode não existir(wizard), o que causa uma exceção
            $didRun=tk_get_context_vars("didRun", "scd_execprocesso_usuario"); //settada como false quando carrega
        }
        catch(\Exception $e){
            $didRun=true; //se não existir, pode ser ignorada
        }

        if($procedure != "" && $didRun){ //se o campo de procedure não estiver vazio e não acabou de carregar dados

            //faz a string
            $parameterString=\Scheduler\Util\ProcedureParameterFunctions::makeParameterString($procedure);
            tk_set_field_value("PARAMETERS",$parameterString);
        }
        else {
            //senão, rodou uma vez, logo pode mudar na próxima
            tk_set_context_vars("didRun", "scd_execprocesso_usuario", true);
        }

        //pega o valor do campo de parâmetros, que pode ter acabado de ser setado ou ter sido recuperado do json em
        //scd_fila_processos_usuario (por isso precisa pegar de novo)
        $parameterFieldValue=tk_get_updated_field_value("PARAMETERS");
        if (isset($parameterFieldValue) && $parameterFieldValue!==""){ //se houver parâmetro, ativa
            tk_enable_field("PARAMETERS");
        }
        else{ //se não houver parâmetro, desabilita
            tk_disable_field("PARAMETERS");
        }

    }
}